package
 {
  import flash.display.Sprite;
  import flash.display.SimpleButton;
  import flash.text.TextField;
  //import flash.text.StyleSheet;

  public class AR_Button extends Sprite
   {
	private var skin          : XML;
	private var label         : String;
	private var icon          : String;
	private var button_width  : int;
	private var button_height : int;

	protected var desktop : AR_Desktop;

    public function AR_Button(dsk : AR_Desktop, skn : XML, lab : String, ico : String, w : int, h : int, type : int = 0)
     {
      var button : SimpleButton = new SimpleButton();
      desktop = dsk;
      skin    = skn;

      switch(type)
       {
		case 1: // Close button
		 {
	      skin.button_up             = skin.button_close_up.toString();
	      skin.button_over           = skin.button_close_over.toString();
	      skin.button_down           = skin.button_close_down.toString();
	      skin.button_hit_test       = skin.button_close_hit_test.toString();
	      skin.button_down_offset_x  = skin.button_close_down_offset_x.toString();
	      skin.button_down_offset_y  = skin.button_close_down_offset_y.toString();
	      skin.button_text_color     = skin.button_close_text_color.toString();
	      skin.button_text_align     = skin.button_close_text_align.toString();
	      skin.button_text_bold      = skin.button_close_text_bold.toString();
	      skin.button_text_italic    = skin.button_close_text_italic.toString();
	      skin.button_text_underline = skin.button_close_text_underline.toString();
		  break;
		 }
		case 2: // Up button
		 {
	      skin.button_up             = skin.button_up_up.toString();
	      skin.button_over           = skin.button_up_over.toString();
	      skin.button_down           = skin.button_up_down.toString();
	      skin.button_hit_test       = skin.button_up_hit_test.toString();
	      skin.button_down_offset_x  = skin.button_up_down_offset_x.toString();
	      skin.button_down_offset_y  = skin.button_up_down_offset_y.toString();
	      skin.button_text_color     = skin.button_up_text_color.toString();
	      skin.button_text_align     = skin.button_up_text_align.toString();
	      skin.button_text_bold      = skin.button_up_text_bold.toString();
	      skin.button_text_italic    = skin.button_up_text_italic.toString();
	      skin.button_text_underline = skin.button_up_text_underline.toString();
		  break;
		 }
		case 3: // Down button
		 {
	      skin.button_up             = skin.button_down_up.toString();
	      skin.button_over           = skin.button_down_over.toString();
	      skin.button_down           = skin.button_down_down.toString();
	      skin.button_hit_test       = skin.button_down_hit_test.toString();
	      skin.button_down_offset_x  = skin.button_down_down_offset_x.toString();
	      skin.button_down_offset_y  = skin.button_down_down_offset_y.toString();
	      skin.button_text_color     = skin.button_down_text_color.toString();
	      skin.button_text_align     = skin.button_down_text_align.toString();
	      skin.button_text_bold      = skin.button_down_text_bold.toString();
	      skin.button_text_italic    = skin.button_down_text_italic.toString();
	      skin.button_text_underline = skin.button_down_text_underline.toString();
		  break;
		 }

       }

      label   = lab;
      icon    = ico;
      button_width  = w;
      button_height = h;
      button.upState       = makeUpState();
      button.overState     = makeOverState();
      button.downState     = makeDownState();
	  button.hitTestState  = makeHitTestState();
      button.useHandCursor = true;
      addChild(button);
     }

    private function makeUpState() : Sprite
     {
	  var label : TextField = new TextField();
	  var image : AR_Image  = new AR_Image(desktop.getSkinPath()+skin.button_up,button_width,button_height);
	  var icon  : AR_Image;
      var state : Sprite    = new Sprite();

      label.styleSheet = desktop.getStyleSheet();
      label.text       = "";
      label.htmlText   = "<span class='buttonLabelUp'>"+this.label+"</span>";
      label.selectable = false;
      label.width      = button_width;
	  label.height     = label.textHeight + 5;
  	  label.x = 0;
      label.y = (button_height - label.height) / 2;
	  state.addChild(image);
	  if(this.icon != "")
	   {
		icon = new AR_Image(desktop.getSkinPath()+this.icon,button_width,button_height);
	    state.addChild(icon);
	   }
	  state.addChild(label);
	  return state;
     }

    private function makeOverState() : Sprite
     {
	  var label : TextField = new TextField();
	  var image : AR_Image  = new AR_Image(desktop.getSkinPath()+skin.button_over,button_width,button_height);
	  var icon  : AR_Image;
      var state : Sprite    = new Sprite();

      label.styleSheet = desktop.getStyleSheet();
      label.text       = "";
	  label.htmlText   = "<span class='buttonLabelOver'>"+this.label+"</span>";
      label.selectable = false;
      label.width      = button_width;
	  label.height     = label.textHeight + 5;
	  label.x = 0;
      label.y = (button_height - label.height) / 2;
	  state.addChild(image);
	  state.addChild(label);
	  if(this.icon != "")
	   {
		icon = new AR_Image(desktop.getSkinPath()+this.icon,button_width,button_height);
	    state.addChild(icon);
	   }
	  return state;
     }

    private function makeDownState() : Sprite
     {
	  var label : TextField = new TextField();
	  var image : AR_Image  = new AR_Image(desktop.getSkinPath()+skin.button_down,button_width,button_height);
	  var icon  : AR_Image;
      var state : Sprite    = new Sprite();

      label.styleSheet = desktop.getStyleSheet();
	  label.htmlText   = "<span class='buttonLabelDown'>"+this.label+"</span>";
      label.selectable = false;
      label.width      = button_width;
	  label.height     = label.textHeight + 5;
	  label.x = 0;
      label.y = (button_height - label.height) / 2;
      label.x += (int)(skin.button_down_offset_x);
      label.y += (int)(skin.button_down_offset_y);
	  state.addChild(image);
	  state.addChild(label);
	  if(this.icon != "")
	   {
		icon = new AR_Image(desktop.getSkinPath()+this.icon,button_width,button_height);
		icon.x += (int)(skin.button_down_offset_x);
		icon.y += (int)(skin.button_down_offset_y);
	    state.addChild(icon);
	   }
      return state;
     }

    private function makeHitTestState() : Sprite
     {//TODO...
      var state : Sprite = new Sprite();

      state.graphics.beginFill(0x000000);
      state.graphics.drawRect(0,0,button_width,button_height);
	  state.graphics.endFill();
	  return state;
     }
   }
 }
