package
 {
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.events.Event;
  import flash.events.MouseEvent;
  import flash.text.StyleSheet;

  public class AR_Desktop extends Sprite
   {
	public  var background : AR_Image;
	public  var logo       : AR_Image;
	public  var title      : TextField;
	public  var page_title : TextField;
    public  var content    : TextField;

    public  var image       : AR_winImage;
    public  var thumbs      : AR_winImagesList;
    public  var sub_menu    : AR_winSubMenu;
	private var main_menu   : AR_winMainMenu;
	private var _COMPONENTS : Array = new Array();

    private var css       : StyleSheet;
	private var xml_file  : AR_XML;
	private var config    : XML;
	private var skin      : XML;
	private var data      : XML;

    public function AR_Desktop()
     {	  
      /*
	  xml_file = new AR_XML("Albume.xml");//TODO verificare se si può caricare un file non da url (cioè da filesystem)
	  var t : TextField = new TextField();
	  t.text        = "xxx";//xml_file.xml.toString();
      t.width       = 540;
	  t.height      = 20;
	  addChild(t);*/

	  if(!xml_file) xml_file = new AR_XML("index.php?action=1");
      xml_file.loader.addEventListener(Event.COMPLETE, exec);
     }

    public function exec(event : Event) : void
	 {
      var found : Boolean;
      var tag   : String;
      var value : String;
      var i     : int;
      var j     : int;
      var k     : int;
      var lg    : int;
      var lc    : int;

      // Load xml file
      xml_file.xml = XML(event.target.data);
      config = new XML(xml_file.xml.config);
      skin   = new XML(xml_file.xml.skin);
      data   = new XML(xml_file.xml.data);

      // Get general skin and add basic parameters (if do not exists) to the specific skins
      lg = skin.general.children().length();
      for(k = 4; k < skin.children().length(); k++)
       {
		lc = skin.children()[k].children().length();
        for(i = 0; i < lg; i++)
	     {
		  found = false;
	      for(j = 0; j < lc; j++)  
	       {
	        if(skin.general.children()[i].name() == skin.children()[k].children()[j].name()) found = true;
	       }
	      if(!found)
	       {
		    tag   = skin.general.children()[i].name();
		    value = skin.general.children()[i];
	        skin.children()[k].appendChild("<"+tag+">"+value+"</"+tag+">");
	       }
         }
       }

      // Load css file
	  css = new StyleSheet();
      css.parseCSS(skin.css);

      // Create desktop
      makeDesktop();
	 }

	private function makeDesktop() : void
	 {
	  // Background
      //graphics.lineStyle(1,0x000000);
	  graphics.beginFill(skin.desktop.bgcolor);
	  graphics.drawRect(0,0,config.width,config.height);
	  graphics.endFill();
	  if(skin.desktop_background)
	   {
	    background = new AR_Image(getSkinPath()+skin.desktop.background,config.width,config.height);
	    background.alpha = skin.desktop.bgalpha;
	    addChild(background);
	   }

	  // Logo
	  logo   = new AR_Image(getLogoPath()+config.logo,0,0,false);
	  logo.x = skin.desktop.logo_x;
	  logo.y = skin.desktop.logo_y;
	  addChild(logo);
	  
	  // Site title
	  title            = new TextField();
	  title.styleSheet = css;
	  title.text       = "";
	  title.htmlText   = "<span class='title'>"+config.title.text()+"</span>";
	  title.selectable = false;
      title.width      = 800;
	  title.height     = 50;
	  title.x          = skin.desktop.title_x;
	  title.y          = skin.desktop.title_y;
	  addChild(title);
	  
	  // Page title
	  page_title            = new TextField();
	  page_title.styleSheet = css;
	  page_title.text       = "";
	  page_title.selectable = false;
      page_title.width      = 800;
	  page_title.height     = 50;
	  page_title.x          = skin.desktop.page_title_x;
	  page_title.y          = skin.desktop.page_title_y;
	  addChild(page_title);
	  
	  // Page content
	  content            = new TextField();
	  content.styleSheet = css;
	  content.text       = "";
	  content.htmlText   = "";
	  content.selectable = false;
      content.width      = 800;
	  content.height     = 560;// meno posizione y
	  content.x          = skin.desktop.content_x;
	  content.y          = skin.desktop.content_y;
	  addChild(content);
	  if(data.page.length()) // Starting page (if exists at least one page)
	   {
	    page_title.htmlText = "<span class='pageTitle'>"+data.page[0].title+"</span>";
	    content.htmlText    = data.page[0].content;
	   }

      // Page foot
      var foot : TextField = new TextField();
      foot.styleSheet      = css;
      foot.text            = "";
      foot.htmlText        = "<span class='foot'> <a class='foot' href=\"http://www.valarsoft.com\" target=\"_blank\">Powered by: AlbumE 0.3</a></span>";
      foot.selectable      = false;
      foot.width           = 800;
      foot.height          = foot.textHeight + 5;
      foot.x               = config.width - foot.width;
      foot.y               = config.height - foot.height;
      addChild(foot);

      // Images window
	  image = new AR_winImage(this,new XML(skin.image),"",640,480);
	  image.x = skin.desktop.image_x;
	  image.y = skin.desktop.image_y;
	  //addChild(image); // Show on startup

      // Thumbnails window
	  thumbs = new AR_winImagesList(this,new XML(skin.thumbnails),"",image,120,420);
	  thumbs.x = skin.desktop.thumbnails_x;
	  thumbs.y = skin.desktop.thumbnails_y;
	  //addChild(thumbs); // Show on startup

      // Sub menu
	  sub_menu = new AR_winSubMenu(this,new XML(skin.sub_menu),data,"",thumbs);
	  sub_menu.x = skin.desktop.sub_menu_x;
	  sub_menu.y = skin.desktop.sub_menu_y;
	  //sub_menu.makeButtons(new XML(data.category[0])); // Default album
	  //addChild(sub_menu); // Show on startup

      // Main menu
	  main_menu = new AR_winMainMenu(this,new XML(skin.main_menu),data,"");
	  main_menu.x = skin.desktop.main_menu_x;
	  main_menu.y = skin.desktop.main_menu_y;
	  main_menu.makeButtons(sub_menu,data);
	  addChild(main_menu);

      // Components
      var l : int;
      for(var i : int = 8; i < skin.children().length(); i++)
       {
        l = _COMPONENTS.push(new AR_winComponent(this,new XML(skin.children()[i]),skin.children()[i].window_title,config.path_components,skin.children()[i].name(),skin.children()[i].window_width,skin.children()[i].window_height));
	    _COMPONENTS[l-1].x = skin.children()[i].window_x;
	    _COMPONENTS[l-1].y = skin.children()[i].window_y;
	    addChild(_COMPONENTS[l-1]);
	   }
	 }

	public function getSkinPath() : String
	 {
	  return config.path_skin.text()+config.skin.text()+"/";
	 }

	public function getLogoPath() : String
	 {
	  return config.path_logo.text();
	 }
	
	public function getSkinGeneral() : XML
	 {
	  // Return general skin for windows and buttons
	  var skn : XML;
	  
	  skn = new XML(skin.general);
	  return skn;
	 }
    
    public function getStyleSheet() : StyleSheet
     {
	  return css;
	 }

   }
 }
