package
 {
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.events.MouseEvent;

  public class AR_Window extends Sprite
   {
	protected var skin    : XML;
	protected var title   : TextField;
    protected var desktop : AR_Desktop;

	private var head        : Sprite;
	private var close       : AR_Button;
	//private var minimize    : AR_Button;//TODO

	protected var body               : Sprite;
	protected var body_top_margin    : int;
	protected var body_left_margin   : int;
	protected var body_right_margin  : int;
	protected var body_bottom_margin : int;
	protected var body_width         : int;
	protected var body_height        : int;

    public function AR_Window(dsk : AR_Desktop, skn : XML, tit : String, w : int, h : int)
     {
	  title   = new TextField();
      desktop = dsk;
      skin    = skn;

      // Window alpha
      alpha = skin.window_alpha;

      // Window body
      body = makeBody(w,h);
      addChild(body);

      // Window head
      if(skin.window_head_on == "1")
       {
        head = makeHead(tit);
	    addChild(head);
	   }

	  // Windows bottom
	  //TODO
     }

    private function makeHead(tit : String) : Sprite
     {
	  var imaged     : AR_Image;
	  var imageh     : AR_Image;
      var head       : Sprite = new Sprite();

      // Draggable head
      imaged = new AR_Image(desktop.getSkinPath()+skin.window_head_draggable,skin.window_head_draggable_width,skin.window_head_draggable_height);
	  imaged.x         = skin.window_head_draggable_x;
	  imaged.y         = skin.window_head_draggable_y;
	  if(skin.window_drag_on == "1")
	   {
	    imaged.addEventListener(MouseEvent.MOUSE_DOWN,takeWindow);
	    imaged.addEventListener(MouseEvent.MOUSE_UP,  releaseWindow);
	   }
      title.selectable  = false;
      title.styleSheet  = desktop.getStyleSheet();
      title.width       = skin.window_title_width;
	  title.height      = skin.window_title_height;
	  title.text        = "";
	  setTitle(tit);
	  title.x           = skin.window_title_x;
	  title.y           = skin.window_title_y;
	  if(skin.window_drag_on == "1")
	   {
	    title.addEventListener(MouseEvent.MOUSE_DOWN,takeWindow);
	    title.addEventListener(MouseEvent.MOUSE_UP,  releaseWindow);
	   }

      // Non draggable head
      imageh = new AR_Image(desktop.getSkinPath()+skin.window_head,skin.window_head_width,skin.window_head_height);
	  imageh.x         = skin.window_head_x;
	  imageh.y         = skin.window_head_y;
	  if(skin.window_close_on == "1")
	   {
        close = new AR_Button(desktop,new XML(skin),skin.button_close_label,skin.button_close_icon,skin.button_close_width,skin.button_close_height,1);
        close.x = skin.button_close_x;
        close.y = skin.button_close_y;
        close.addEventListener(MouseEvent.CLICK, closeWindow);
	   }
	  head.addChild(imageh);
	  head.addChild(imaged);
	  head.addChild(title);
	  if(skin.window_close_on == "1") head.addChild(close);

	  return head;
     }

    protected function makeBody(w : int, h : int) : Sprite
     {
	  var image : AR_Image;
      var body  : Sprite   = new Sprite();

      body_width  = w;
      body_height = h;
      body_top_margin    = skin.window_body_top_margin;
	  body_left_margin   = skin.window_body_left_margin;
	  body_right_margin  = skin.window_body_right_margin;
	  body_bottom_margin = skin.window_body_bottom_margin;
      image = new AR_Image(desktop.getSkinPath()+skin.window_body,body_width+body_left_margin+body_right_margin,body_height+body_top_margin+body_bottom_margin);
	  body.addChild(image);
	  return body;
	 }

    private function takeWindow(event : MouseEvent) : void
     {
      alpha = skin.window_take_alpha;
	  parent.setChildIndex(this,parent.numChildren - 1);
	  startDrag();
     }

    private function releaseWindow(event : MouseEvent) : void
     {
      alpha = skin.window_alpha;
	  stopDrag();
     }

    private function closeWindow(event : MouseEvent) : void
     {
      desktop.removeChild(this);
     }

    public function getDesktop() : AR_Desktop
     {
	  return desktop;
	 }

    public function setTitle(t : String) : void
     {
      title.htmlText = "<span class='windowTitle'>"+t+"</span>";
     }
   }
 }
