package
 {
  public class AR_winMainMenu extends AR_Window
   {
	private var _BUTTONS      : Array = new Array();
	private var button_width  : int;
	private var button_height : int;
	private var spacing       : int;
	private var layout        : int;

    public function AR_winMainMenu(dsk : AR_Desktop, skn : XML, dat : XML, tit : String)
     {
	  var w : int;
	  var h : int;
	  var n : int;

      button_width  = skn.button_width;
      button_height = skn.button_height;
      spacing       = skn.button_spacing;
      if(skn.window_layout == "horizontal") layout = 1;
      else                                  layout = 0;

      n = dat.page.length() + dat.category.length();
      if(layout) // Horizontal layout
       {
	    w = (button_width + spacing) * n - spacing;
	    h = button_height;
	   }
	  else
	   {
		w = button_width;
	    h = (button_height + spacing) * n - spacing;
	   }

      super(dsk,skn,tit,w,h);
     }

    public function makeButtons(sub_menu : AR_winSubMenu, data : XML) : void
     {
	  var i : int; 

      // Pages buttons
	  for(i = 0; i < data.page.length(); i++)
	   {
        var bp : AR_btnPage = new AR_btnPage(desktop,skin,data.page[i].label,"",button_width,button_height);

	    bp.setDataArray(new XML(data.page[i]));
	    addButton(bp);
	   }
      // Categories buttons
	  for(i = 0; i < data.category.length(); i++)
	   {
        var bc : AR_btnCategory = new AR_btnCategory(desktop,skin,data.category[i].title,"",button_width,button_height);

	    bc.setSubMenu(sub_menu);
	    bc.setDataArray(new XML(data.category[i]));
	    addButton(bc);
	   }
	 }

    public function addButton(b : AR_Button) : void
     {
      var l : int = _BUTTONS.push(b);
      body.addChild(_BUTTONS[l-1]);
      if(layout) // Horizontal layout
       {
        _BUTTONS[l-1].x = (button_width + spacing) * (l-1) + body_left_margin;
        _BUTTONS[l-1].y = body_top_margin;
       }
      else
       {
		_BUTTONS[l-1].x = body_left_margin;
        _BUTTONS[l-1].y = (button_height + spacing) * (l-1) + body_top_margin;
	   }
	 }
   }
 }
