<?php

 // THIS FILE IS PART OF ALBUME
 // www.valarsoft.com

 defined('ALB_cEXEC') or die('Denied');

 class AlbumE
  {
   private $stage,$action;
   private $config_file,$xml_file,$html_file;
   private $_CONFIG;
   private $_SKIN;

   function __construct($config_file)
    {
     // Include configuration file
     $this->config_file = $config_file;
     if(file_exists($this->config_file)) require_once($this->config_file);
     else {
		   AlbumE::writeConfig('',true);
           require_once($this->config_file);
	      }
     $this->_CONFIG = $_CONFIG;

     // Html and XML file
     $this->html_file = 'Albume.html';
     $this->xml_file  = 'Albume.xml';

     // Include skin
     require_once(ALB_cPATH_SKINS.$this->_CONFIG['skin']."/".$this->_CONFIG['skin'].".php");

     // Load components parameters
     $fd  = opendir(ALB_cPATH_COMPONENTS);
     while(($file = readdir($fd)))
      {
	   if(isset($_AUX)) unset($_AUX);
	   if($file != "." && $file != "..")
        {
		 if(is_dir(ALB_cPATH_COMPONENTS.$file))
		  {
           require(ALB_cPATH_COMPONENTS.$file."/".$file.".php"); // Include components
           $_AUX[$file] = $_SKIN[$file];
           // Override component parameters for the skin
           if(file_exists(ALB_cPATH_SKINS.$this->_CONFIG['skin']."/components.php")) require_once(ALB_cPATH_SKINS.$this->_CONFIG['skin']."/components.php");
           foreach($_AUX[$file] as $key => $value)
            {
			 if(!isset($_SKIN[$file][$key])) $_SKIN[$file][$key] = $value;
			}
           if(!$_SKIN[$file]['component_on']) unset($_SKIN[$file]); // Disable component
	      }
	    }
      }
     closedir($fd);

     $this->_SKIN = $_SKIN;

     // Get action
     if(isset($_GET['stage'])) $this->stage = intval($_GET['stage']);
     else                      $this->stage = ALB_cSTAGE_HOME;
     if(isset($_GET['action'])) $this->action = intval($_GET['action']);
     else                       $this->action = ALB_cACTION_SHOW_HOME;

     // Check system
     if(!AlbumE::checkSystem())
      {
	   $this->stage  = ALB_cSTAGE_ADMIN;
	   if($this->action != ALB_cACTION_LOGIN &&
	      $this->action != ALB_cACTION_LOGOUT) $this->action = ALB_cACTION_SHOW_HOME;
      }
     
     switch($this->stage)
      {
	   case ALB_cSTAGE_ADMIN:
	    {
         AlbumE::execAdmin();
		 break;
	    }
       default:
        {
		 AlbumE::execHome();
		}
	  }
    }

   public function getConfigFieldsArray()
    {
	 return array('skin','logo','title','width','height','thumbs_width','thumbs_height');
	}

   public function getPasswordFieldsArray()
    {
	 return array('old_password','new_password','confirm_password');
	}

   public function getLoginFieldsArray()
    {
	 return array('password');
	}

   public function execHome()
    {
	 switch($this->action)
	  {
       case ALB_cACTION_SHOW_XML: // Output xml data
        {
	     echo AlbumE::makeXML();
	     break;
	    }
       default: // Render flash content
        {
	     echo AlbumE::home($this->_CONFIG['title']);
	    }
      }
    }

   public function execAdmin()
    {
	 echo AlbumE::adminHead("AlbumE ".ALB_cVERSION);
     if(AlbumE::checkAuthentication())
      {
	   echo AlbumE::adminMenu();
	   switch($this->action)
	    {
         case ALB_cACTION_EDIT_CONFIG: // Configuration form
          {
	       echo AlbumE::editConfig();
	       break;
	      }
         case ALB_cACTION_SAVE_CONFIG: // Save configuration
          {
	       echo AlbumE::saveConfig();
	       break;
	      }
         case ALB_cACTION_EDIT_PASSWORD: // Change password form
          {
	       echo AlbumE::editPassword();
	       break;
	      }
         case ALB_cACTION_SAVE_PASSWORD: // Save password
          {
	       echo AlbumE::savePassword();
	       break;
	      }
         case ALB_cACTION_SAVE_XML: // Save html page and xml data to a file
          {
	       AlbumE::home($this->_CONFIG['title'],true);
	       echo Util::message("File \"".$this->html_file."\" created");
	       AlbumE::makeXML(true);
	       echo Util::message("XML data saved in: \"".$this->xml_file."\"");
	       break;
	      }
         case ALB_cACTION_LOGOUT: // Logout
          {
		   setcookie("password","",time()-3600);
		   header("Location: index.php?stage=".ALB_cSTAGE_ADMIN);
	       break;
	      }
	     default:
	      {
		   echo Util::message("AlbumE ".ALB_cVERSION);
		   echo AlbumE::showSystem();
	  	  }
	    }
	  }
	 else
	  {
	   echo AlbumE::adminMenu(true);
	   switch($this->action)
	    {
         case ALB_cACTION_LOGIN: // Login
          {
		   setcookie("password",md5($_POST['password']));
		   header("Location: index.php?stage=".ALB_cSTAGE_ADMIN);
	       break;
	      }
	     default:
	      {
		   echo AlbumE::login();
	  	  }
	  	}
	  }
	 echo AlbumE::adminFoot();
	}

   public function makeXML($to_file = false)
    {
     $str  = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";
     $str .= "<albume>";
     $str .= AlbumE::makeXMLConfig();
     $str .= AlbumE::makeXMLSkin();
     $str .= AlbumE::makeXMLData();
     $str .= "</albume>";
     if($to_file)
      {
       $fd = fopen($this->xml_file,'w');
       fwrite($fd,$str);
       fclose($fd);
      }
     else return $str;
    }

   public function makeXMLConfig()
    {
     $str =  "<config>";
     $str .= "<path_skin>".ALB_cPATH_SKINS."</path_skin>";
     //$str .= "<path_data>".ALB_cPATH_DATA ."</path_data>";
     $str .= "<path_logo>".ALB_cPATH_LOGO ."</path_logo>";
     $str .= "<path_components>".ALB_cPATH_COMPONENTS."</path_components>";
     foreach($this->_CONFIG as $key => $value)
      $str .= "<$key>".$this->_CONFIG[$key]."</$key>";
     $str .= "</config>";
     return $str;
    }

   public function makeXMLSkin()
    {
     $css_file = ALB_cPATH_SKINS.$this->_CONFIG['skin']."/".$this->_CONFIG['skin'].".css";
     $fd  = fopen($css_file,"r");
     $css = fread($fd,filesize($css_file));
     fclose($fd);

     $str  = "<skin>";
     $str .= "<path>".ALB_cPATH_SKINS."</path>";
     $str .= "<css>$css</css>";
     foreach($this->_SKIN as $key => $value)
      {
       $str .= "<$key>";
       foreach($this->_SKIN[$key] as $sub_key => $sub_value)
        $str .= "<$sub_key>".$this->_SKIN[$key][$sub_key]."</$sub_key>";
       $str .= "</$key>";
      }     
     $str .= "</skin>";
     return $str;
    }

   public function makeXMLData()
    {
	 $str  = "<data>";
	 $str .= AlbumE::makeXMLPages(ALB_cPATH_PAGES);	 
	 $str .= AlbumE::makeXMLCategories(ALB_cPATH_IMAGES);
     $str .= "</data>";
     return $str;
    }

   public function makeXMLPages($path)
    {
     $i   = 0;
     $str = "";
     $fd  = opendir($path);
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != "..")
        {
	     if(is_dir($path.$file))
	      {
           $_FILE = file($path.$file."/content.txt");
           $content = "";
           foreach ($_FILE as $i => $line)
            {
             if($i == 0) $label   =  $line;
             if($i == 1) $title   =  $line;
             if($i >= 2) $content .= $line;
		    }
           $str .= "<page>";
           $str .= "<label>$label</label>";
           $str .= "<title>$title</title>";
           $str .= "<content><![CDATA[$content]]></content>";
           $str .= "</page>";
	      }
	    }
	  }
	 closedir($fd);
     return $str;
    }

   public function makeXMLCategories($path)
    {
     $i   = 0;
     $str = "";
     $fd  = opendir($path);
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != "..")
        {
	     if(is_dir($path.$file))
	      {
           $str .= "<category>";
           $str .= "<title>$file</title>";     
           $str .= AlbumE::makeXMLAlbums($path.$file."/");
           $str .= "</category>";
	      }
	    }
	  }
	 closedir($fd);
     return $str;
    }

   public function makeXMLAlbums($path)
    {
     $i   = 0;
     $str = "";
     $fd  = opendir($path);
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != "..")
        {
	     if(is_dir($path.$file))
	      {
           $str .= "<album>";
           $str .= "<title>$file</title>";
           $str .= AlbumE::makeXMLItems($path.$file."/");
           $str .= "</album>";
           AlbumE::makeThumbnails($path.$file."/");
	      }
	    }
      }
     closedir($fd);
     return $str;
    }

   public function makeXMLItems($path)
    {
     $i   = 0;
     $str = "";
     $fd  = opendir($path);
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != ".." && $file != "index.html" && $file != "_t") // Do not process ".", "..", "index.html" and "_t"
        {
         $str .= "<item>";
         $str .= "<thumb>".$path."_t/".$file."</thumb>";
         $str .= "<image>".$path.      $file."</image>";
         $str .= "</item>";
         $i++;
	    }
      }
     closedir($fd);
     return $str;
    }

   public function home($title,$to_file = false)
    {
     $str = "<html>
              <head>
               <title>$title</title>
              </head>
              <body leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">
               <table width=\"1%\" align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
                <tr><td>
                 <br>
	             <object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0\" width=\"".$this->_CONFIG['width']."\" height=\"".$this->_CONFIG['height']."\">
                  <param name=\"movie\" value=\"Albume.swf\">
                  <param name=\"quality\" value=\"high\">
                  <embed src=\"Albume.swf\" quality=\"high\" pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" type=\"application/x-shockwave-flash\" width=\"".$this->_CONFIG['width']."\" height=\"".$this->_CONFIG['height']."\"></embed> 
                 </object>
                </td></tr>
               </table>
              </body>
             </html>";
     if($to_file)
      {
       $fd = fopen($this->html_file,'w');
       fwrite($fd,$str);
       fclose($fd);
      }
     else return $str;
    }

   public function adminHead($title)
    {
     $str = "<html>
              <head>
               <title>$title</title>
               <link rel=\"stylesheet\" href=\"".ALB_cPATH_CORE."admin.css\" type=\"text/css\">
              </head>
              <body>
               <table width=\"100%\" align=\"center\" border=\"0\" cellspacing=\"2\" cellpadding=\"4\">";
     return $str;
 	}

   public function adminMenu($short = false)
    {
     $str =  "<tr bgcolor=\"#bbddff\">
               <td colspan=\"2\">
                <nobr><a href=\"index.php\"                                                                   >Home</a></nobr>";
     if(!$short)
      $str .= "  <nobr> | <a href=\"index.php?stage=".ALB_cSTAGE_ADMIN."\"                                     >Admin home</a></nobr>
                 <nobr> | <a href=\"index.php?stage=".ALB_cSTAGE_ADMIN."&action=".ALB_cACTION_EDIT_CONFIG."\"  >Edit configuration</a></nobr>
                 <nobr> | <a href=\"index.php?stage=".ALB_cSTAGE_ADMIN."&action=".ALB_cACTION_EDIT_PASSWORD."\">Change password</a></nobr>
                 <nobr> | <a href=\"index.php?stage=".ALB_cSTAGE_ADMIN."&action=".ALB_cACTION_SAVE_XML."\"     >Write files</a></nobr>
                 <nobr> | <a href=\"index.php?stage=".ALB_cSTAGE_ADMIN."&action=".ALB_cACTION_LOGOUT."\"       >Logout</a></nobr>";
     $str .= " </td>
             </tr>";
     return $str;
 	}

   public function login()
    {
	 $_COLOR  = Util::getColorArray(AlbumE::getLoginFieldsArray());
	 $_CONFIG = $this->_CONFIG;
	 $title = "Login";
	 require(ALB_cPATH_CORE."admin_login_form.inc");
     return $content;
    }

   public function checkConfigError($_ARR)
    {
	 if($_ARR['width'] <= 100) return 1;
	 return 0;
	}

   public function editConfig()
    {
	 $_COLOR  = Util::getColorArray(AlbumE::getConfigFieldsArray());
	 $_CONFIG = $this->_CONFIG;
	 $title = "Edit configuration";
	 require(ALB_cPATH_CORE."admin_config_form.inc");
     return $content;
    }

   public function saveConfig()
    {
	 $_COLOR  = Util::getColorArray(AlbumE::getConfigFieldsArray());
	 $_CONFIG = Util::getPostValueArray(AlbumE::getConfigFieldsArray());
	 $_CONFIG['password'] = $this->_CONFIG['password'];
	 $error = AlbumE::checkConfigError($_CONFIG);
	 if($error)
	  {
	   switch($error)
	    {
		 case 1: { $title = "Bad SWF width"; $_COLOR['width'] = '#ff9999'; break; }
		}
	   require(ALB_cPATH_CORE."admin_config_form.inc");
       return $content;
      }
     else
      {
	   AlbumE::writeConfig($_CONFIG);
	   return Util::message("Configuration saved");
      }
    }

   public function checkPasswordError($_ARR)
    {
	 if(md5($_ARR['old_password']) != $_ARR['password'])    return 1;
	 if($_ARR['new_password'] != $_ARR['confirm_password']) return 2;
	 if(strlen($_ARR['new_password']) < 5)                  return 3;
	 return 0;
	}

   public function editPassword()
    {
	 $_COLOR  = Util::getColorArray(AlbumE::getPasswordFieldsArray());
	 $_CONFIG = $this->_CONFIG;
	 $title = "Edit configuration";
	 require(ALB_cPATH_CORE."admin_password_form.inc");
     return $content;
    }

   public function savePassword()
    {
	 $_COLOR  = Util::getColorArray(AlbumE::getPasswordFieldsArray());
	 $_CONFIG = $this->_CONFIG;
	 $_PASSWD = Util::getPostValueArray(AlbumE::getPasswordFieldsArray());
	 $_PASSWD['password'] = $_CONFIG['password'];
	 $_CONFIG['password'] = md5($_PASSWD['new_password']);
	 $error = AlbumE::checkPasswordError($_PASSWD);
	 if($error)
	  {
	   switch($error)
	    {
		 case 1: { $title = "Old password do not match"; $_COLOR['old_password'] = '#ff9999'; break; }
		 case 2: { $title = "Passwords do not match";    $_COLOR['new_password'] = $_COLOR['confirm_password'] = '#ff9999'; break; }
		 case 3: { $title = "Password too short";        $_COLOR['new_password'] = $_COLOR['confirm_password'] = '#ff9999'; break; }
		}
	   require(ALB_cPATH_CORE."admin_password_form.inc");
       return $content;
      }
     else
      {
	   AlbumE::writeConfig($_CONFIG);
	   setcookie("password",$_CONFIG['password']);
	   return Util::message("Password changed");
      }
    }

   public function adminFoot()
    {
     $str = "   <tr bgcolor=\"#bbddff\">
                 <td colspan=\"2\" align=\"right\"><a href=\"http://www.valarsoft.com\" target=\"_blank\">Powered by: AlbumE ".ALB_cVERSION."</a></td>
                </tr>
               </table>
              </body>
             </html>";
     return $str;
	}

   public function checkAuthentication()
    {
     // Check authentication cookies (return ture or false)
     // Cookies not set
     if(!isset($_COOKIE['password'])) return false;
     else
      {
       // Cookies already set, check it
       if($_COOKIE['password'] == $this->_CONFIG['password']) return true;
      }
     setcookie("password","",time()-3600); // Remove bad cookies
     return false;
    }

   public function makeThumbnails($path)
    {
     if(!file_exists($path."_t")) mkdir($path."_t");
     $fd = opendir($path);
     while(($file = readdir($fd)))
      {
       if($file != "." && $file != ".." && $file != "index.html" && $file != "_t") // Do not process ".", "..", "index.html" and "_t"
        {
         if(!file_exists($path."_t/".$file))
	      {
	       $_SIZE = getimagesize($path.$file);
           $dst_img = @imagecreatetruecolor(120,90);
           switch($_SIZE['mime'])
            {
		     case "image/jpeg":
		      {
               $src_img = @imagecreatefromjpeg($path.$file);
               @imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, 120, 90, $_SIZE[0], $_SIZE[1]);
               @imagejpeg($dst_img,$path."_t/".$file,76);
               break;
	          }
	         case "image/gif":
	          {
               $src_img = @imagecreatefromgif($path.$file);
               @imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, 120, 90, $_SIZE[0], $_SIZE[1]);
               @imagegif($dst_img,$path."_t/".$file);
		       break;
		      }
		     case "image/png":
		      {
               $src_img = @imagecreatefrompng($path.$file);
               @imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, 120, 90, $_SIZE[0], $_SIZE[1]);
               @imagepng($dst_img,$path."_t/".$file);
		       break;
		      }
	        }
           @imagedestroy($src_img);
           @imagedestroy($dst_img);
          }
        }
      }
     closedir($fd);
    }

   public function writeConfig($_CONFIG,$default = false)
    {
     $str = "<?php

              // THIS FILE IS PART OF ALBUME
              // www.valarsoft.com

              defined('ALB_cEXEC') or die('Denied');

              // AlbumE configuration
              ".chr(36)."_CONFIG = array
               (";

	 if($default)
	  {
       $str .= "'skin'          => 'default',
                'logo'          => 'logo.png',
                'title'         => 'AlbumE',
                'width'         => 800,
                'height'        => 560,
                'password'      => '".md5('admin')."',
                'thumbs_width'  => 120,
                'thumbs_height' => 90";
      }
     else
      {
       $str .= "'skin'          => '".$_CONFIG['skin']."',
                'title'         => '".$_CONFIG['title']."',
                'logo'          => '".$_CONFIG['logo']."',
                'width'         => ".$_CONFIG['width'].",
                'height'        => ".$_CONFIG['height'].",
                'password'      => '".$_CONFIG['password']."',
                'thumbs_width'  => ".$_CONFIG['thumbs_width'].",
                'thumbs_height' => ".$_CONFIG['thumbs_height']."";
      }
	 $str .= ");
	          ?>";
     // Open file and save configuration
     $fd = fopen($this->config_file,'w');
     fwrite($fd,$str);
     fclose($fd);
	}

   public function checkSystem()
    {
	 return intval(phpversion() >= 5)                &&
	        Util::isFolderWritable('.')              &&
	        Util::isFolderWritable(ALB_cPATH_IMAGES) &&
	        Util::isFolderWritable(ALB_cPATH_PAGES)  &&
	        extension_loaded('gd');
	}

   public function showSystem()
    {
	 $str = "";
	 if(intval(phpversion() >= 5))                $str .= Util::message(Util::renderImg('ok.png') ." PHP Version >= 5.0.0",1);
	 else                                         $str .= Util::message(Util::renderImg('bad.png')." Error: PHP Version < 5.0.0",2);
	 if(Util::isFolderWritable('.'))              $str .= Util::message(Util::renderImg('ok.png') ." Root directory writable!");
     else                                         $str .= Util::message(Util::renderImg('bad.png')." Error: Root directory is not writable!",2);
	 if(Util::isFolderWritable(ALB_cPATH_IMAGES)) $str .= Util::message(Util::renderImg('ok.png') ." ".ALB_cPATH_IMAGES." directory writable!",1);
     else                                         $str .= Util::message(Util::renderImg('bad.png')." Error: ".ALB_cPATH_IMAGES." directory is not writable!",2);
	 if(Util::isFolderWritable(ALB_cPATH_PAGES))  $str .= Util::message(Util::renderImg('ok.png') ." ".ALB_cPATH_PAGES." directory writable!");
     else                                         $str .= Util::message(Util::renderImg('bad.png')." Error: ".ALB_cPATH_PAGES." directory is not writable!",2);
	 if(extension_loaded('gd'))                   $str .= Util::message(Util::renderImg('ok.png') ." PHP GD extension loaded!",1);
     else                                         $str .= Util::message(Util::renderImg('bad.png')." Error: PHP GD extension not loaded!",2);
     if(AlbumE::checkSystem()) $str .= Util::message("System configuration ok, you can use AlbumE!");
     else                          $str .= Util::message("System configuration bad, fix the errors before use AlbumE!",2);
	 return $str;
	}

  }

?>
